package com.fp.persistence.pviaticos.param;

import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import javax.persistence.Transient;

/**Clase que hace referencia a la Clave Primaria de VIA_CIUDAD_USUARIO*/
@Embeddable
public class ViaCiudadUsuarioKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="COD_ACTIVIDAD_CATALOG", nullable=false,updatable=false)

/**
* Codigo de catalogo actividades, TESORERIA, CONTABILIDAD
*/
private String cod_actividad_catalog;

@Column(name="COD_CIUDAD_CATALOG", nullable=false,updatable=false)

/**
* Codigo de catalogo  1 Quito, 2 Guayaquil, 3 Cuenca, 4 
*/
private String cod_ciudad_catalog;

/**Contructor por defecto*/
public ViaCiudadUsuarioKey(){}
/**Contructor de ViaCiudadUsuarioKey
@param pCod_actividad_catalog Codigo de catalogo actividades, TESORERIA, CONTABILIDAD
@param pCod_ciudad_catalog Codigo de catalogo  1 Quito, 2 Guayaquil, 3 Cuenca, 4 
*/
public ViaCiudadUsuarioKey(String pCod_actividad_catalog,String pCod_ciudad_catalog){
 cod_actividad_catalog=pCod_actividad_catalog;
 cod_ciudad_catalog=pCod_ciudad_catalog;
}
/**Obtiene el valor de cod_actividad_catalog
@return valor de cod_actividad_catalog*/
public String getCod_actividad_catalog(){
  return cod_actividad_catalog;
}
/**Fija el valor de cod_actividad_catalog
@param pCod_actividad_catalog nuevo Valor de cod_actividad_catalog*/
public void setCod_actividad_catalog(String pCod_actividad_catalog){
  cod_actividad_catalog=pCod_actividad_catalog;
}

/**Obtiene el valor de cod_ciudad_catalog
@return valor de cod_ciudad_catalog*/
public String getCod_ciudad_catalog(){
  return cod_ciudad_catalog;
}
/**Fija el valor de cod_ciudad_catalog
@param pCod_ciudad_catalog nuevo Valor de cod_ciudad_catalog*/
public void setCod_ciudad_catalog(String pCod_ciudad_catalog){
  cod_ciudad_catalog=pCod_ciudad_catalog;
}

/**Implementacion de la comparacion de ViaCiudadUsuarioKey
@param o Objeto de comparacion
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof ViaCiudadUsuarioKey))return false;
  ViaCiudadUsuarioKey that = (ViaCiudadUsuarioKey) o;
  if (this.getCod_actividad_catalog() == null || that.getCod_actividad_catalog() == null){
      return false;
  }
  if (! this.getCod_actividad_catalog().equals(that.getCod_actividad_catalog())){
    return false;
  }
  if (this.getCod_ciudad_catalog() == null || that.getCod_ciudad_catalog() == null){
      return false;
  }
  if (! this.getCod_ciudad_catalog().equals(that.getCod_ciudad_catalog())){
    return false;
  }
  return true;
}
/**Implementacion del metodo hashCode bajo el patron de Bloch
@return hashCode de la instancia ViaCiudadUsuarioKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getCod_actividad_catalog() == null ? 0 : this.getCod_actividad_catalog().hashCode());
    result = result * 37 + (this.getCod_ciudad_catalog() == null ? 0 : this.getCod_ciudad_catalog().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
}
